/*
 * physmem.h
 * 
 * last update: 29-Aug-2012 by Ervin Denes (PYSMEM_DEV)
 * last update: 19-Jul-2012 by Gabor Kiss (PHYSMEM_MAXDEVICE set to 12)
 * last update: 19-Aug-2011 by Ervin Denes 
 * last update: 07-Jul-2011 by Ervin Denes 
 * last update: 26-Apr-2011 by Ervin Denes 
 * last update: 05-Feb-2009 by Marc Frauman
 * last update: 02-Aug-2006 by Klaus Schossmaier
 */

#ifndef __physmem_h__
#define __physmem_h__

#define PHYSMEM_MAJOR 122
#define PHYSMEM_NAME  "physmem"
#define PHYSMEM_DEV   "/dev/physmem"

  /* used to define size of physmem0 */
#define PHYSMEM_96MB 0x006000000L
  /* used to get to address above 4GB memory hole, if present */
#define MEM_4GB 0x100000000ULL

#define PHYSMEM_MAXDEVICE 12 /* physmem1 to 11 hold all memory above physmem0 */

#define PHYSMEM_GETADDR  _IOR('x', 1, u_long)  /* get physical address */
#define PHYSMEM_GETSIZE  _IOR('x', 2, u_long)  /* get usable size in bytes (no hole present in virtual memory) */

#define PHYSMEM_GETFULLSIZE  _IOR('x', 3, u_long)  /* get complete size, with hole if present (direct mapping of physical memory - to be used with following calls) */
#define PHYSMEM_GETNUMMEMZONES  _IOR('x', 4, int)  /* get number of memory zones */
#define PHYSMEM_GETMEMZONES  _IOR('x', 5, u_long)  /* get physical address of memory zones (call with an array of PHYSMEM_GETNUMZONES elements of type struct memZone) */

 /* struct to hold info about physical memory zone */
struct memZoneStruct{
  unsigned long start;
  unsigned long end;
  unsigned long size;
};

#endif
